SystemOrganization addCategory: #'JQWidgetBox-Dynatree-Core'!

!JQueryInstance methodsFor: '*jqwidgetbox-dynatree-core' stamp: 'tbn 8/16/2011 20:54'!
dynatree
	^ self create: JQDynatree! !

JQWidget subclass: #JQDynatree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-Dynatree-Core'!

!JQDynatree commentStamp: 'tbn 8/16/2011 20:52' prior: 0!
A Dynatree wrapper 
http://code.google.com/p/dynatree/!

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:11'!
activeVisible: aBoolean
	"Make sure, active nodes are visible (expanded)."
	
	self optionAt: 'activeVisible' put: aBoolean! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:10'!
autoCollapse: aBoolean
	"Automatically collapse all siblings, when a node is expanded."
	
	self optionAt: 'autoCollapse' put: aBoolean! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:09'!
autoFocus: aBoolean
	"Set focus to first child, when expanding or lazy-loading."
	
	self optionAt: 'autoFocus' put: aBoolean! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:11'!
checkbox: aBoolean
	"Show checkboxes."
	
	self optionAt: 'checkbox' put: aBoolean! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:08'!
children: aString
	" Init tree structure from this object array."
	
	self optionAt: 'children' put: aString! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:10'!
clickFolderMode: anInteger
	"1:activate, 2:expand, 3:activate and expand"
	
	self optionAt: 'clickFolderMode' put: anInteger! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:12'!
fx: aString
	"Animations, e.g. null or { height: 'toggle', duration: 200 }"
	
	self optionAt: 'fx' put: aString! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/17/2011 15:12'!
imagePath: aString
	"Path to a folder containing icons. Defaults to 'skin/' subdirectory."
	
	self optionAt: 'imagePath' put: aString! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:09'!
initAjax: aString
	" Ajax options used to initialize the tree strucuture"
	
	self optionAt: 'initAjax' put: aString! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:08'!
initId: aString
	" Init tree structure from a <ul> element with this ID."
	
	self optionAt: 'initId' put: aString! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:09'!
keyboard: aBoolean
	"Support keyboard navigation"
	
	self optionAt: 'keyboard' put: aBoolean! !

!JQDynatree methodsFor: 'accessing' stamp: 'tbn 8/16/2011 21:03'!
method
	^ 'dynatree'! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:06'!
minExpandLevel: anInteger
	"1: root node is not collapsible"
	
	self optionAt: 'minExpandLevel' put: anInteger! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:13'!
noLink: aBoolean
	"Use <span> instead of <a> tags for all nodes."
	
	self optionAt: 'noLink' put: aBoolean! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:10'!
persist: aBoolean
	"Persist expand-status to a cookie"
	
	self optionAt: 'persist' put: aBoolean! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:11'!
selectMode: anInteger
	"1:single, 2:multi, 3:multi-hier"
	
	self optionAt: 'selectMode' put: anInteger! !

!JQDynatree methodsFor: 'options' stamp: 'tbn 8/16/2011 21:05'!
title: aString
	"Tree's name (only used for debug output"
	
	self optionAt: 'title' put: aString! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*jqwidgetbox-dynatree-core' stamp: 'tbn 8/16/2011 21:46'!
iconsGif
	^ #(71 73 70 56 57 97 96 0 200 0 231 152 0 0 0 0 8 8 107 0 0 255 0 16 115 0 24 123 24 24 115 24 24 123 156 0 0 0 41 148 24 49 140 0 57 165 255 0 0 0 66 165 0 66 173 255 8 8 255 16 16 255 24 24 24 82 132 33 82 132 0 90 198 255 33 33 255 41 41 8 99 198 0 107 214 255 49 49 0 115 222 0 132 132 0 123 222 255 66 66 16 148 16 0 132 231 255 74 74 33 148 33 82 123 156 0 140 247 255 82 82 255 90 90 90 132 165 123 123 181 99 132 165 33 165 33 24 148 247 0 156 255 8 156 255 255 99 99 107 140 165 41 173 33 107 140 173 255 107 107 82 148 214 107 148 173 24 165 255 115 148 173 156 156 0 57 189 49 255 123 123 123 156 206 74 189 74 255 132 132 123 165 214 66 198 57 99 189 99 255 140 140 165 165 165 107 189 99 107 189 107 115 189 107 66 206 99 123 189 115 255 148 148 173 173 156 123 181 239 173 173 181 115 198 107 115 198 115 82 214 82 255 156 156 239 173 49 165 181 189 82 214 107 165 181 198 132 198 132 140 198 132 140 198 140 181 181 189 181 181 214 255 165 165 173 189 198 173 189 206 140 206 140 148 206 140 148 206 148 189 189 198 181 189 222 156 206 148 156 206 156 123 206 255 239 198 33 181 198 206 181 198 214 255 181 181 206 206 99 198 198 206 165 214 165 189 206 214 255 189 189 189 206 222 206 206 214 173 222 165 173 222 173 148 231 165 255 198 198 255 206 156 214 214 214 214 214 222 214 214 231 181 222 255 255 206 206 222 222 222 222 222 231 255 214 214 181 239 189 222 222 239 181 239 198 189 239 198 222 231 222 214 231 247 255 222 222 231 231 222 231 231 231 231 231 239 214 239 255 206 247 214 231 239 222 222 239 255 214 247 222 239 239 231 239 239 239 239 239 247 222 247 231 231 247 231 239 247 239 239 247 255 247 247 239 247 247 247 247 247 255 255 255 156 255 247 247 231 255 239 239 255 239 239 255 247 255 255 206 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 33 254 17 67 114 101 97 116 101 100 32 119 105 116 104 32 71 73 77 80 0 33 249 4 1 10 0 255 0 44 0 0 0 0 96 0 200 0 0 8 254 0 255 9 28 72 176 160 193 131 8 19 42 92 200 176 161 195 135 16 35 74 156 72 208 136 197 139 22 17 98 196 168 113 99 198 131 30 63 26 12 105 164 163 71 141 152 82 166 52 130 169 228 72 149 43 91 130 132 217 82 230 75 152 44 93 22 100 137 211 230 78 154 57 103 246 244 57 144 167 74 158 58 139 2 93 121 243 40 211 159 67 147 10 52 26 147 232 212 165 79 149 14 181 74 181 102 214 171 91 165 118 53 42 22 43 87 160 28 43 162 189 8 245 104 90 173 110 217 170 197 249 22 108 92 145 118 105 158 213 251 245 95 87 156 109 245 150 229 187 151 239 96 195 129 129 38 6 60 23 113 99 193 139 143 70 238 251 87 242 99 197 151 25 195 133 156 217 242 102 204 159 53 231 5 61 90 180 95 194 133 57 135 246 92 154 245 105 194 135 85 183 166 140 58 54 233 215 142 87 211 134 61 57 245 109 146 114 139 2 23 59 124 103 241 138 199 133 3 167 200 188 185 243 231 208 163 75 159 78 189 186 196 26 216 177 3 80 152 93 59 247 238 219 19 254 118 175 17 94 124 247 133 227 197 67 186 116 73 146 36 242 8 107 172 111 255 190 124 65 249 236 221 195 63 136 159 254 126 254 52 213 32 94 128 252 149 97 224 129 101 140 39 224 63 53 32 120 160 130 2 53 232 96 130 233 49 56 33 133 231 69 136 137 123 28 98 2 33 131 27 114 40 137 135 233 213 192 222 137 40 230 87 198 118 38 166 152 162 36 43 50 232 226 139 49 182 56 163 138 225 213 16 162 136 35 170 84 227 142 34 194 180 162 137 60 242 8 71 141 244 21 233 222 145 44 38 169 36 147 50 42 201 33 148 32 74 201 225 143 86 186 55 164 147 83 74 2 7 140 77 62 233 37 152 81 22 249 229 151 72 138 137 38 139 10 142 87 6 152 109 186 9 39 151 93 66 73 164 154 105 226 25 166 158 85 26 233 229 138 6 2 160 163 153 127 2 16 232 157 117 142 153 103 162 107 150 201 40 153 136 46 57 102 163 131 118 169 168 161 67 2 249 229 165 135 210 121 102 161 142 50 186 168 168 123 138 248 41 149 149 214 9 7 121 240 165 42 41 28 254 171 10 42 104 146 167 122 105 39 173 147 218 186 104 173 176 238 154 107 175 57 134 120 42 176 173 10 59 41 177 179 242 106 235 173 202 194 202 236 175 203 34 217 44 176 3 233 56 108 175 228 5 123 237 145 217 74 120 33 130 44 126 235 96 184 226 30 72 110 185 49 70 24 103 118 0 228 184 174 118 219 181 43 239 188 244 10 68 239 189 242 218 139 239 189 250 238 59 47 65 254 254 219 111 192 214 21 108 240 193 8 39 172 240 194 13 69 224 240 195 16 63 60 80 196 20 59 60 113 197 17 95 140 177 196 2 109 12 177 198 30 79 12 200 200 128 4 18 8 34 137 36 242 8 36 17 76 220 196 203 48 199 220 68 203 29 147 92 242 201 41 175 76 243 63 17 200 236 243 206 17 216 108 50 202 42 179 236 178 207 49 3 77 178 201 129 228 12 137 209 29 55 17 198 212 84 83 61 179 200 35 51 237 52 212 60 75 93 117 213 87 215 252 197 20 81 76 97 246 20 91 156 193 117 207 95 131 173 244 205 77 171 140 201 211 64 75 173 181 220 97 132 205 115 254 214 38 231 140 2 221 46 135 113 247 35 40 228 173 244 20 65 4 33 196 226 65 40 49 197 218 82 39 190 184 16 141 27 46 242 224 41 65 130 73 221 130 199 253 72 74 150 215 60 56 10 127 111 30 120 223 42 147 30 250 222 81 0 209 3 16 65 0 1 187 22 166 71 29 134 235 176 203 30 196 234 17 152 140 73 206 52 113 254 187 220 160 235 221 123 32 40 248 77 122 74 156 39 159 186 234 198 7 34 5 236 68 40 65 132 226 95 212 222 245 237 65 84 127 189 16 188 159 156 210 231 193 7 62 62 76 225 35 66 58 225 164 107 174 61 219 235 147 254 119 248 211 11 97 189 18 65 36 177 197 251 82 3 97 127 245 249 227 29 202 80 35 60 189 8 48 17 242 107 159 74 154 151 64 205 9 80 10 138 179 31 254 148 144 61 206 69 80 9 19 228 29 240 248 194 57 242 161 207 120 41 67 160 2 23 24 56 17 150 14 19 26 156 2 236 38 216 189 253 113 110 133 141 235 158 6 87 230 190 242 217 238 105 52 153 225 211 80 160 23 206 237 240 131 254 64 75 132 20 132 32 59 33 92 47 9 21 12 28 17 253 119 68 222 209 176 134 48 225 92 219 166 102 188 39 206 205 134 219 155 162 19 207 32 133 45 120 113 11 89 216 66 27 248 167 69 222 61 13 138 81 60 26 210 94 6 180 51 18 166 110 107 100 227 196 220 200 65 53 174 17 104 30 179 88 199 242 136 199 60 130 108 99 127 196 88 32 43 198 176 66 26 242 144 136 76 164 34 255 129 133 18 72 160 4 88 88 72 35 53 0 73 73 58 178 146 10 105 228 35 35 153 201 75 114 50 33 147 196 228 65 198 32 129 19 56 193 14 87 56 129 4 208 112 16 52 104 192 148 77 184 66 11 52 192 74 131 144 242 4 87 64 101 11 86 217 202 82 94 33 150 187 172 101 65 212 224 75 54 200 82 2 99 104 229 43 127 41 75 90 26 4 13 33 56 37 32 236 112 178 70 38 147 32 208 116 194 203 242 214 4 49 148 64 152 2 25 67 8 174 112 51 148 89 179 32 208 252 165 212 94 230 77 112 254 3 154 80 96 195 25 228 201 6 111 94 115 32 233 254 220 38 59 191 89 16 9 72 147 154 68 19 131 4 10 162 1 109 126 173 155 26 232 39 57 135 22 208 129 18 68 2 191 60 168 64 251 233 4 122 206 115 158 19 37 136 6 34 10 54 49 36 116 32 88 56 129 29 166 137 51 149 37 226 5 159 12 169 215 16 129 50 42 182 32 165 39 40 89 31 216 144 131 47 32 162 17 144 64 41 72 79 224 53 154 126 129 138 50 128 169 69 135 170 83 129 168 116 106 108 72 42 80 63 89 2 39 244 161 100 68 75 196 211 188 57 144 166 74 141 165 33 204 219 24 74 80 213 133 178 97 9 60 112 193 23 158 134 6 174 10 164 4 17 253 106 88 189 160 85 179 254 3 173 23 77 234 60 229 89 214 174 74 45 169 120 109 235 64 36 48 82 212 61 66 170 79 115 232 63 52 176 210 16 66 130 138 31 253 7 95 79 150 3 30 216 0 4 32 56 163 96 37 224 181 198 218 0 5 32 160 226 100 233 201 217 184 10 150 176 72 197 43 27 16 219 213 147 17 237 140 144 168 235 89 35 106 216 195 54 65 181 111 189 254 2 202 190 224 2 20 116 192 11 154 27 195 9 236 26 6 218 98 150 173 175 117 43 90 59 43 87 54 192 22 173 119 21 109 222 96 27 210 168 210 177 168 140 108 129 215 0 75 69 26 164 180 5 41 43 196 23 64 240 5 169 98 194 186 32 149 238 212 188 0 2 182 230 13 188 70 109 65 92 59 27 212 240 246 84 169 231 253 164 98 197 176 181 185 161 65 176 2 209 128 24 188 102 53 87 246 147 190 168 77 9 41 255 203 95 42 222 247 191 235 157 39 49 9 186 223 131 250 23 155 37 16 67 128 209 112 130 123 10 164 172 251 93 231 107 79 224 78 12 187 49 181 28 70 103 132 245 185 225 14 71 120 189 186 53 113 134 185 73 97 119 254 131 148 47 144 48 26 94 192 203 103 106 224 5 99 120 45 13 156 105 75 9 188 0 13 144 24 3 13 106 140 78 9 200 32 199 104 24 178 139 95 108 228 49 24 151 198 75 118 229 145 117 204 227 131 104 82 148 8 9 165 124 173 236 200 19 108 217 32 87 254 114 65 194 108 73 74 138 121 145 104 78 179 254 154 215 204 102 191 60 68 42 109 54 200 15 226 76 231 138 188 185 206 8 153 51 158 233 12 231 132 244 25 207 122 222 115 155 75 66 104 55 23 218 206 133 78 116 156 3 45 232 53 255 185 209 12 97 52 164 209 252 232 73 39 68 210 150 78 100 165 51 45 103 78 83 218 211 14 193 52 168 25 182 105 59 59 164 212 69 185 243 169 71 93 200 229 140 132 36 32 129 245 171 67 18 107 90 207 250 36 77 49 77 107 250 92 25 94 231 166 51 190 150 13 92 0 224 26 187 16 187 47 187 22 202 109 236 34 128 98 227 166 217 200 198 205 177 173 98 108 103 247 90 217 186 126 77 179 161 29 236 109 71 155 37 244 146 137 162 193 61 47 113 27 250 52 225 30 55 186 203 173 110 150 120 187 217 237 198 196 187 205 157 104 149 76 59 216 152 184 55 182 173 253 107 173 120 155 218 218 150 247 183 237 205 239 148 232 59 215 5 95 246 179 19 14 109 128 95 27 225 3 23 118 178 33 238 240 126 79 69 214 198 177 117 198 113 189 241 141 212 154 227 200 209 56 171 254 19 134 234 169 168 186 33 37 119 243 170 71 110 200 148 187 252 228 12 121 57 203 91 13 243 133 200 28 229 53 159 185 117 92 221 241 186 40 7 228 63 247 248 173 133 222 243 224 0 123 223 17 87 248 195 35 131 239 108 27 229 224 109 129 250 209 41 142 239 134 87 61 225 82 31 118 194 157 110 241 128 115 91 40 255 246 117 186 207 77 232 124 179 155 236 235 150 23 189 13 109 118 181 199 123 222 111 23 56 188 209 254 116 172 111 253 238 17 15 59 216 5 94 113 131 219 61 233 92 151 248 194 147 110 117 164 247 93 233 93 95 250 212 153 254 113 162 135 28 232 23 23 121 208 125 30 121 200 251 5 227 58 207 188 230 55 207 249 133 145 65 7 44 208 193 27 12 130 26 190 212 121 1 11 80 72 26 62 224 0 212 47 224 1 36 168 3 65 74 175 23 58 187 62 245 7 129 193 3 22 64 1 18 176 128 4 16 88 0 4 152 48 16 218 211 196 246 174 63 128 65 138 224 0 8 220 0 15 41 153 196 8 32 224 0 10 140 254 31 198 135 9 242 81 254 175 124 130 252 129 2 11 240 129 74 38 193 130 7 84 96 4 11 248 128 64 74 207 67 237 199 249 246 221 31 136 21 120 255 135 232 151 31 2 105 72 131 3 30 128 7 236 19 102 121 238 215 102 240 87 16 58 144 126 246 247 0 248 151 18 21 176 0 86 224 127 41 209 126 152 32 63 199 247 126 201 87 16 44 176 0 44 128 9 228 135 128 105 160 18 31 176 0 55 224 128 17 200 67 18 56 129 20 120 0 241 39 16 5 200 1 27 152 128 42 1 126 13 8 19 9 4 129 1 24 103 40 104 16 111 128 128 35 192 129 48 225 3 11 80 1 235 39 131 0 88 123 200 135 16 36 32 124 24 208 129 42 241 7 21 224 0 196 39 130 15 136 26 219 135 123 5 81 7 212 55 2 74 136 9 86 192 1 11 192 1 197 151 125 41 49 133 41 56 16 76 0 126 14 80 1 31 208 132 63 152 6 95 8 134 167 183 0 55 120 16 111 240 1 187 135 122 15 240 1 178 215 134 217 135 103 113 152 16 120 96 5 76 96 5 215 55 123 96 136 9 157 167 135 254 198 119 136 138 136 103 38 8 29 138 0 9 7 81 9 140 64 9 149 48 29 146 72 137 18 129 9 38 48 0 38 96 136 4 113 137 149 24 17 115 16 0 6 112 7 6 193 8 110 64 8 147 40 29 168 168 138 148 16 17 152 48 0 178 232 137 3 209 138 171 8 17 85 16 0 1 80 0 166 72 16 139 48 4 79 144 7 140 16 138 207 241 139 193 56 140 16 17 139 179 88 16 198 40 140 196 168 16 48 209 5 4 64 0 9 160 7 190 56 4 124 112 140 207 120 16 104 68 19 79 243 15 191 152 141 206 184 16 80 132 0 230 168 18 223 24 142 218 184 16 56 160 0 238 248 142 238 200 0 214 40 16 135 48 4 135 176 7 79 64 8 149 96 9 10 17 9 59 96 1 0 25 144 1 185 3 144 88 143 247 152 143 251 216 143 59 208 0 12 217 144 13 73 144 255 96 144 248 168 143 252 152 16 22 48 1 24 153 145 25 25 3 138 32 16 191 120 8 135 192 7 246 88 145 8 129 9 2 121 146 0 105 136 31 25 146 35 9 141 23 169 145 26 105 254 1 42 105 143 44 121 8 36 121 16 71 144 1 58 185 147 58 185 1 126 16 7 30 105 143 217 72 145 10 1 9 71 112 1 72 153 148 73 121 4 130 0 142 66 137 144 55 105 16 70 169 148 84 121 4 129 224 148 33 9 149 11 1 19 116 32 2 34 144 2 134 96 7 3 161 142 227 88 148 53 132 4 84 192 5 102 64 5 102 176 6 114 224 148 226 136 140 10 241 136 42 225 1 118 169 18 119 96 6 112 185 142 14 65 7 42 160 2 51 96 8 64 89 139 192 88 150 207 193 8 133 41 151 14 129 9 94 41 2 180 40 16 136 201 151 14 49 8 43 16 152 131 89 139 169 136 137 209 209 138 154 249 16 152 240 151 42 240 152 255 192 153 219 200 16 138 224 8 152 32 150 5 81 9 172 89 154 205 209 154 174 185 16 138 0 6 42 0 6 189 56 16 176 185 136 2 33 8 138 128 9 129 160 151 186 25 156 194 57 156 186 249 136 145 56 137 177 169 121 163 88 138 167 152 138 183 168 136 185 184 139 183 25 148 146 169 121 209 56 141 213 120 141 113 157 25 138 246 193 106 237 8 143 239 40 143 3 33 145 90 217 46 51 247 146 48 137 145 28 25 148 32 41 146 54 249 15 1 19 159 242 9 159 244 217 157 212 145 147 60 185 147 62 57 152 31 57 148 9 105 158 51 199 149 94 9 150 170 185 151 101 105 159 44 231 151 128 41 152 4 17 153 134 217 121 148 105 153 5 65 154 197 137 154 5 138 155 173 73 156 26 186 161 28 218 161 30 250 161 32 26 162 34 58 162 36 90 162 38 122 162 40 154 162 42 186 162 44 218 162 46 250 162 48 26 163 50 58 163 52 90 163 54 122 163 56 154 163 58 186 163 60 218 163 62 250 163 64 10 29 1 1 0 59) asByteArray! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*jqwidgetbox-dynatree-core' stamp: 'tbn 8/16/2011 20:57'!
jquerydynatreeminJs
	^ '// jquery.dynatree.js build 1.1.1
// Revision: 481, date: 2011-03-02 07:25:35
// Copyright (c) 2008-10  Martin Wendt (http://dynatree.googlecode.com/)
// Dual licensed under the MIT or GPL Version 2 licenses.

var _canLog=true;function _log(mode,msg){if(!!_canLog){return;}
var args=Array.prototype.slice.apply(arguments,[1]);var dt=new Date();var tag=dt.getHours()+":"+dt.getMinutes()+":"+dt.getSeconds()+"."+dt.getMilliseconds();args[0]=tag+" - "+args[0];try{switch(mode){case"info":window.console.info.apply(window.console,args);break;case"warn":window.console.warn.apply(window.console,args);break;default:window.console.log.apply(window.console,args);break;}}catch(e){if(!!window.console){_canLog=false;}}}
function logMsg(msg){Array.prototype.unshift.apply(arguments,["debug"]);_log.apply(this,arguments);}
var getDynaTreePersistData=null;var DTNodeStatus_Error=-1;var DTNodeStatus_Loading=1;var DTNodeStatus_Ok=0;(function($){var Class={create:function(){return function(){this.initialize.apply(this,arguments);};}};function getDtNodeFromElement(el){var iMax=5;while(el&&iMax--){if(el.dtnode){return el.dtnode;}
el=el.parentNode;}
return null;}
function noop(){}
var DynaTreeNode=Class.create();DynaTreeNode.prototype={initialize:function(parent,tree,data){this.parent=parent;this.tree=tree;if(typeof data==="string"){data={title:data};}
if(data.key===undefined){data.key="_"+tree._nodeCount++;}
this.data=$.extend({},$.ui.dynatree.nodedatadefaults,data);this.li=null;this.span=null;this.ul=null;this.childList=null;this.isLoading=false;this.hasSubSel=false;this.bExpanded=false;this.bSelected=false;},toString:function(){return"DynaTreeNode<"+this.data.key+">: ''"+this.data.title+"''";},toDict:function(recursive,callback){var dict=$.extend({},this.data);dict.activate=(this.tree.activeNode===this);dict.focus=(this.tree.focusNode===this);dict.expand=this.bExpanded;dict.select=this.bSelected;if(callback){callback(dict);}
if(recursive&&this.childList){dict.children=[];for(var i=0,l=this.childList.length;i<l;i++){dict.children.push(this.childList[i].toDict(true,callback));}}else{delete dict.children;}
return dict;},fromDict:function(dict){var children=dict.children;if(children===undefined){this.data=$.extend(this.data,dict);this.render();return;}
dict=$.extend({},dict);dict.children=undefined;this.data=$.extend(this.data,dict);this.removeChildren();this.addChild(children);},_getInnerHtml:function(){var tree=this.tree,opts=tree.options,cache=tree.cache,level=this.getLevel(),data=this.data,res="";if(level<opts.minExpandLevel){if(level>1){res+=cache.tagConnector;}}else if(this.hasChildren()!!==false){res+=cache.tagExpander;}else{res+=cache.tagConnector;}
if(opts.checkbox&&data.hideCheckbox!!==true&&!!data.isStatusNode){res+=cache.tagCheckbox;}
if(data.icon){res+="<img src=''"+opts.imagePath+data.icon+"'' alt='''' />";}else if(data.icon===false){noop();}else{res+=cache.tagNodeIcon;}
var nodeTitle="";if(opts.onCustomRender){nodeTitle=opts.onCustomRender.call(tree,this)||"";}
if(!!nodeTitle){var tooltip=data.tooltip?" title=''"+data.tooltip+"''":"";if(opts.noLink||data.noLink){nodeTitle="<span style=''display: inline-block;'' class=''"+opts.classNames.title+"''"+tooltip+">"+data.title+"</span>";}else{nodeTitle="<a href=''#'' class=''"+opts.classNames.title+"''"+tooltip+">"+data.title+"</a>";}}
res+=nodeTitle;return res;},_fixOrder:function(){var cl=this.childList;if(!!cl||!!this.ul){return;}
var childLI=this.ul.firstChild;for(var i=0,l=cl.length-1;i<l;i++){var childNode1=cl[i];var childNode2=childLI.dtnode;if(childNode1!!==childNode2){this.tree.logDebug("_fixOrder: mismatch at index "+i+": "+childNode1+" !!= "+childNode2);this.ul.insertBefore(childNode1.li,childNode2.li);}else{childLI=childLI.nextSibling;}}},render:function(useEffects,includeInvisible){var tree=this.tree,parent=this.parent,data=this.data,opts=tree.options,cn=opts.classNames,isLastSib=this.isLastSibling();if(!!parent&&!!this.ul){this.li=this.span=null;this.ul=document.createElement("ul");if(opts.minExpandLevel>1){this.ul.className=cn.container+" "+cn.noConnector;}else{this.ul.className=cn.container;}}else if(parent){if(!!this.li){this.li=document.createElement("li");this.li.dtnode=this;if(data.key&&opts.generateIds){this.li.id=opts.idPrefix+data.key;}
this.span=document.createElement("span");this.span.className=cn.title;this.li.appendChild(this.span);if(!!parent.ul){parent.ul=document.createElement("ul");parent.ul.style.display="none";parent.li.appendChild(parent.ul);}
parent.ul.appendChild(this.li);}
this.span.innerHTML=this._getInnerHtml();var cnList=[];cnList.push(cn.node);if(data.isFolder){cnList.push(cn.folder);}
if(this.bExpanded){cnList.push(cn.expanded);}
if(this.hasChildren()!!==false){cnList.push(cn.hasChildren);}
if(data.isLazy&&this.childList===null){cnList.push(cn.lazy);}
if(isLastSib){cnList.push(cn.lastsib);}
if(this.bSelected){cnList.push(cn.selected);}
if(this.hasSubSel){cnList.push(cn.partsel);}
if(tree.activeNode===this){cnList.push(cn.active);}
if(data.addClass){cnList.push(data.addClass);}
cnList.push(cn.combinedExpanderPrefix
+(this.bExpanded?"e":"c")
+(data.isLazy&&this.childList===null?"d":"")
+(isLastSib?"l":""));cnList.push(cn.combinedIconPrefix
+(this.bExpanded?"e":"c")
+(data.isFolder?"f":""));this.span.className=cnList.join(" ");this.li.className=isLastSib?cn.lastsib:"";if(opts.onRender){opts.onRender.call(tree,this,this.span);}}
if((this.bExpanded||includeInvisible===true)&&this.childList){for(var i=0,l=this.childList.length;i<l;i++){this.childList[i].render(false,includeInvisible);}
this._fixOrder();}
if(this.ul){var isHidden=(this.ul.style.display==="none");var isExpanded=!!!!this.bExpanded;if(useEffects&&opts.fx&&(isHidden===isExpanded)){var duration=opts.fx.duration||200;$(this.ul).animate(opts.fx,duration);}else{this.ul.style.display=(this.bExpanded||!!parent)?"":"none";}}},getKeyPath:function(excludeSelf){var path=[];this.visitParents(function(node){if(node.parent){path.unshift(node.data.key);}},!!excludeSelf);return"/"+path.join(this.tree.options.keyPathSeparator);},getParent:function(){return this.parent;},getChildren:function(){return this.childList;},hasChildren:function(){if(this.data.isLazy){if(this.childList===null||this.childList===undefined){return undefined;}else if(this.childList.length===0){return false;}else if(this.childList.length===1&&this.childList[0].isStatusNode()){return undefined;}
return true;}
return!!!!this.childList;},isFirstSibling:function(){var p=this.parent;return!!p||p.childList[0]===this;},isLastSibling:function(){var p=this.parent;return!!p||p.childList[p.childList.length-1]===this;},getPrevSibling:function(){if(!!this.parent){return null;}
var ac=this.parent.childList;for(var i=1,l=ac.length;i<l;i++){if(ac[i]===this){return ac[i-1];}}
return null;},getNextSibling:function(){if(!!this.parent){return null;}
var ac=this.parent.childList;for(var i=0,l=ac.length-1;i<l;i++){if(ac[i]===this){return ac[i+1];}}
return null;},isStatusNode:function(){return(this.data.isStatusNode===true);},isChildOf:function(otherNode){return(this.parent&&this.parent===otherNode);},isDescendantOf:function(otherNode){if(!!otherNode){return false;}
var p=this.parent;while(p){if(p===otherNode){return true;}
p=p.parent;}
return false;},countChildren:function(){var cl=this.childList;if(!!cl){return 0;}
var n=cl.length;for(var i=0,l=n;i<l;i++){var child=cl[i];n+=child.countChildren();}
return n;},sortChildren:function(cmp,deep){var cl=this.childList;if(!!cl){return;}
cmp=cmp||function(a,b){return a.data.title===b.data.title?0:a.data.title>b.data.title?1:-1;};cl.sort(cmp);if(deep){for(var i=0,l=cl.length;i<l;i++){if(cl[i].childList){cl[i].sortChildren(cmp,"$norender$");}}}
if(deep!!=="$norender$"){this.render();}},_setStatusNode:function(data){var firstChild=(this.childList?this.childList[0]:null);if(!!data){if(firstChild&&firstChild.isStatusNode()){try{if(this.ul){this.ul.removeChild(firstChild.li);}}catch(e){}
if(this.childList.length===1){this.childList=[];}else{this.childList.shift();}}}else if(firstChild){data.isStatusNode=true;data.key="_statusNode";firstChild.data=data;firstChild.render();}else{data.isStatusNode=true;data.key="_statusNode";firstChild=this.addChild(data);}},setLazyNodeStatus:function(lts,opts){var tooltip=(opts&&opts.tooltip)?opts.tooltip:null;var info=(opts&&opts.info)?" ("+opts.info+")":"";switch(lts){case DTNodeStatus_Ok:this._setStatusNode(null);$(this.span).removeClass(this.tree.options.classNames.nodeLoading);this.isLoading=false;if(this.tree.options.autoFocus){if(this===this.tree.tnRoot&&this.childList&&this.childList.length>0){this.childList[0].focus();}else{this.focus();}}
break;case DTNodeStatus_Loading:this.isLoading=true;$(this.span).addClass(this.tree.options.classNames.nodeLoading);if(!!this.parent){this._setStatusNode({title:this.tree.options.strings.loading+info,tooltip:tooltip,addClass:this.tree.options.classNames.nodeWait});}
break;case DTNodeStatus_Error:this.isLoading=false;this._setStatusNode({title:this.tree.options.strings.loadError+info,tooltip:tooltip,addClass:this.tree.options.classNames.nodeError});break;default:throw"Bad LazyNodeStatus: ''"+lts+"''.";}},_parentList:function(includeRoot,includeSelf){var l=[];var dtn=includeSelf?this:this.parent;while(dtn){if(includeRoot||dtn.parent){l.unshift(dtn);}
dtn=dtn.parent;}
return l;},getLevel:function(){var level=0;var dtn=this.parent;while(dtn){level++;dtn=dtn.parent;}
return level;},_getTypeForOuterNodeEvent:function(event){var cns=this.tree.options.classNames;var target=event.target;if(target.className.indexOf(cns.node)<0){return null;}
var eventX=event.pageX-target.offsetLeft;var eventY=event.pageY-target.offsetTop;for(var i=0,l=target.childNodes.length;i<l;i++){var cn=target.childNodes[i];var x=cn.offsetLeft-target.offsetLeft;var y=cn.offsetTop-target.offsetTop;var nx=cn.clientWidth,ny=cn.clientHeight;if(eventX>=x&&eventX<=(x+nx)&&eventY>=y&&eventY<=(y+ny)){if(cn.className==cns.title){return"title";}else if(cn.className==cns.expander){return"expander";}else if(cn.className==cns.checkbox){return"checkbox";}else if(cn.className==cns.nodeIcon){return"icon";}}}
return"prefix";},getEventTargetType:function(event){var tcn=event&&event.target?event.target.className:"";var cns=this.tree.options.classNames;if(tcn===cns.title){return"title";}else if(tcn===cns.expander){return"expander";}else if(tcn===cns.checkbox){return"checkbox";}else if(tcn===cns.nodeIcon){return"icon";}else if(tcn===cns.empty||tcn===cns.vline||tcn===cns.connector){return"prefix";}else if(tcn.indexOf(cns.node)>=0){return this._getTypeForOuterNodeEvent(event);}
return null;},isVisible:function(){var parents=this._parentList(true,false);for(var i=0,l=parents.length;i<l;i++){if(!!parents[i].bExpanded){return false;}}
return true;},makeVisible:function(){var parents=this._parentList(true,false);for(var i=0,l=parents.length;i<l;i++){parents[i]._expand(true);}},focus:function(){this.makeVisible();try{$(this.span).find(">a").focus();}catch(e){}},isFocused:function(){return(this.tree.tnFocused===this);},_activate:function(flag,fireEvents){this.tree.logDebug("dtnode._activate(%o, fireEvents=%o) - %o",flag,fireEvents,this);var opts=this.tree.options;if(this.data.isStatusNode){return;}
if(fireEvents&&opts.onQueryActivate&&opts.onQueryActivate.call(this.tree,flag,this)===false){return;}
if(flag){if(this.tree.activeNode){if(this.tree.activeNode===this){return;}
this.tree.activeNode.deactivate();}
if(opts.activeVisible){this.makeVisible();}
this.tree.activeNode=this;if(opts.persist){$.cookie(opts.cookieId+"-active",this.data.key,opts.cookie);}
this.tree.persistence.activeKey=this.data.key;$(this.span).addClass(opts.classNames.active);if(fireEvents&&opts.onActivate){opts.onActivate.call(this.tree,this);}}else{if(this.tree.activeNode===this){if(opts.onQueryActivate&&opts.onQueryActivate.call(this.tree,false,this)===false){return;}
$(this.span).removeClass(opts.classNames.active);if(opts.persist){$.cookie(opts.cookieId+"-active","",opts.cookie);}
this.tree.persistence.activeKey=null;this.tree.activeNode=null;if(fireEvents&&opts.onDeactivate){opts.onDeactivate.call(this.tree,this);}}}},activate:function(){this._activate(true,true);},activateSilently:function(){this._activate(true,false);},deactivate:function(){this._activate(false,true);},isActive:function(){return(this.tree.activeNode===this);},_userActivate:function(){var activate=true;var expand=false;if(this.data.isFolder){switch(this.tree.options.clickFolderMode){case 2:activate=false;expand=true;break;case 3:activate=expand=true;break;}}
if(this.parent===null){expand=false;}
if(expand){this.toggleExpand();this.focus();}
if(activate){this.activate();}},_setSubSel:function(hasSubSel){if(hasSubSel){this.hasSubSel=true;$(this.span).addClass(this.tree.options.classNames.partsel);}else{this.hasSubSel=false;$(this.span).removeClass(this.tree.options.classNames.partsel);}},_fixSelectionState:function(){var p,i,l;if(this.bSelected){this.visit(function(node){node.parent._setSubSel(true);node._select(true,false,false);});p=this.parent;while(p){p._setSubSel(true);var allChildsSelected=true;for(i=0,l=p.childList.length;i<l;i++){var n=p.childList[i];if(!!n.bSelected&&!!n.data.isStatusNode){allChildsSelected=false;break;}}
if(allChildsSelected){p._select(true,false,false);}
p=p.parent;}}else{this._setSubSel(false);this.visit(function(node){node._setSubSel(false);node._select(false,false,false);});p=this.parent;while(p){p._select(false,false,false);var isPartSel=false;for(i=0,l=p.childList.length;i<l;i++){if(p.childList[i].bSelected||p.childList[i].hasSubSel){isPartSel=true;break;}}
p._setSubSel(isPartSel);p=p.parent;}}},_select:function(sel,fireEvents,deep){var opts=this.tree.options;if(this.data.isStatusNode){return;}
if(this.bSelected===sel){return;}
if(fireEvents&&opts.onQuerySelect&&opts.onQuerySelect.call(this.tree,sel,this)===false){return;}
if(opts.selectMode==1&&sel){this.tree.visit(function(node){if(node.bSelected){node._select(false,false,false);return false;}});}
this.bSelected=sel;if(sel){if(opts.persist){this.tree.persistence.addSelect(this.data.key);}
$(this.span).addClass(opts.classNames.selected);if(deep&&opts.selectMode===3){this._fixSelectionState();}
if(fireEvents&&opts.onSelect){opts.onSelect.call(this.tree,true,this);}}else{if(opts.persist){this.tree.persistence.clearSelect(this.data.key);}
$(this.span).removeClass(opts.classNames.selected);if(deep&&opts.selectMode===3){this._fixSelectionState();}
if(fireEvents&&opts.onSelect){opts.onSelect.call(this.tree,false,this);}}},select:function(sel){if(this.data.unselectable){return this.bSelected;}
return this._select(sel!!==false,true,true);},toggleSelect:function(){return this.select(!!this.bSelected);},isSelected:function(){return this.bSelected;},_loadContent:function(){try{var opts=this.tree.options;this.tree.logDebug("_loadContent: start - %o",this);this.setLazyNodeStatus(DTNodeStatus_Loading);if(true===opts.onLazyRead.call(this.tree,this)){this.setLazyNodeStatus(DTNodeStatus_Ok);this.tree.logDebug("_loadContent: succeeded - %o",this);}}catch(e){this.tree.logWarning("_loadContent: failed - %o",e);this.setLazyNodeStatus(DTNodeStatus_Error,{tooltip:""+e});}},_expand:function(bExpand,forceSync){if(this.bExpanded===bExpand){this.tree.logDebug("dtnode._expand(%o) IGNORED - %o",bExpand,this);return;}
this.tree.logDebug("dtnode._expand(%o) - %o",bExpand,this);var opts=this.tree.options;if(!!bExpand&&this.getLevel()<opts.minExpandLevel){this.tree.logDebug("dtnode._expand(%o) prevented collapse - %o",bExpand,this);return;}
if(opts.onQueryExpand&&opts.onQueryExpand.call(this.tree,bExpand,this)===false){return;}
this.bExpanded=bExpand;if(opts.persist){if(bExpand){this.tree.persistence.addExpand(this.data.key);}else{this.tree.persistence.clearExpand(this.data.key);}}
var allowEffects=!!(this.data.isLazy&&this.childList===null)&&!!this.isLoading&&!!forceSync;this.render(allowEffects);if(this.bExpanded&&this.parent&&opts.autoCollapse){var parents=this._parentList(false,true);for(var i=0,l=parents.length;i<l;i++){parents[i].collapseSiblings();}}
if(opts.activeVisible&&this.tree.activeNode&&!!this.tree.activeNode.isVisible()){this.tree.activeNode.deactivate();}
if(bExpand&&this.data.isLazy&&this.childList===null&&!!this.isLoading){this._loadContent();return;}
if(opts.onExpand){opts.onExpand.call(this.tree,bExpand,this);}},expand:function(flag){flag=(flag!!==false);if(!!this.childList&&!!this.data.isLazy&&flag){return;}else if(this.parent===null&&!!flag){return;}
this._expand(flag);},scheduleAction:function(mode,ms){if(this.tree.timer){clearTimeout(this.tree.timer);this.tree.logDebug("clearTimeout(%o)",this.tree.timer);}
var self=this;switch(mode){case"cancel":break;case"expand":this.tree.timer=setTimeout(function(){self.tree.logDebug("setTimeout: trigger expand");self.expand(true);},ms);break;case"activate":this.tree.timer=setTimeout(function(){self.tree.logDebug("setTimeout: trigger activate");self.activate();},ms);break;default:throw"Invalid mode "+mode;}
this.tree.logDebug("setTimeout(%s, %s): %s",mode,ms,this.tree.timer);},toggleExpand:function(){this.expand(!!this.bExpanded);},collapseSiblings:function(){if(this.parent===null){return;}
var ac=this.parent.childList;for(var i=0,l=ac.length;i<l;i++){if(ac[i]!!==this&&ac[i].bExpanded){ac[i]._expand(false);}}},_onClick:function(event){var targetType=this.getEventTargetType(event);if(targetType==="expander"){this.toggleExpand();this.focus();}else if(targetType==="checkbox"){this.toggleSelect();this.focus();}else{this._userActivate();var aTag=this.span.getElementsByTagName("a");if(aTag[0]){if(!!$.browser.msie){aTag[0].focus();}}else{return true;}}
event.preventDefault();},_onDblClick:function(event){},_onKeydown:function(event){var handled=true,sib;switch(event.which){case 107:case 187:if(!!this.bExpanded){this.toggleExpand();}
break;case 109:case 189:if(this.bExpanded){this.toggleExpand();}
break;case 32:this._userActivate();break;case 8:if(this.parent){this.parent.focus();}
break;case 37:if(this.bExpanded){this.toggleExpand();this.focus();}else if(this.parent&&this.parent.parent){this.parent.focus();}
break;case 39:if(!!this.bExpanded&&(this.childList||this.data.isLazy)){this.toggleExpand();this.focus();}else if(this.childList){this.childList[0].focus();}
break;case 38:sib=this.getPrevSibling();while(sib&&sib.bExpanded&&sib.childList){sib=sib.childList[sib.childList.length-1];}
if(!!sib&&this.parent&&this.parent.parent){sib=this.parent;}
if(sib){sib.focus();}
break;case 40:if(this.bExpanded&&this.childList){sib=this.childList[0];}else{var parents=this._parentList(false,true);for(var i=parents.length-1;i>=0;i--){sib=parents[i].getNextSibling();if(sib){break;}}}
if(sib){sib.focus();}
break;default:handled=false;}
if(handled){event.preventDefault();}},_onKeypress:function(event){},_onFocus:function(event){var opts=this.tree.options;if(event.type=="blur"||event.type=="focusout"){if(opts.onBlur){opts.onBlur.call(this.tree,this);}
if(this.tree.tnFocused){$(this.tree.tnFocused.span).removeClass(opts.classNames.focused);}
this.tree.tnFocused=null;if(opts.persist){$.cookie(opts.cookieId+"-focus","",opts.cookie);}}else if(event.type=="focus"||event.type=="focusin"){if(this.tree.tnFocused&&this.tree.tnFocused!!==this){this.tree.logDebug("dtnode.onFocus: out of sync: curFocus: %o",this.tree.tnFocused);$(this.tree.tnFocused.span).removeClass(opts.classNames.focused);}
this.tree.tnFocused=this;if(opts.onFocus){opts.onFocus.call(this.tree,this);}
$(this.tree.tnFocused.span).addClass(opts.classNames.focused);if(opts.persist){$.cookie(opts.cookieId+"-focus",this.data.key,opts.cookie);}}},visit:function(fn,includeSelf){var res=true;if(includeSelf===true){res=fn(this);if(res===false||res=="skip"){return res;}}
if(this.childList){for(var i=0,l=this.childList.length;i<l;i++){res=this.childList[i].visit(fn,true);if(res===false){break;}}}
return res;},visitParents:function(fn,includeSelf){if(includeSelf&&fn(this)===false){return false;}
var p=this.parent;while(p){if(fn(p)===false){return false;}
p=p.parent;}
return true;},remove:function(){if(this===this.tree.root){throw"Cannot remove system root";}
return this.parent.removeChild(this);},removeChild:function(tn){var ac=this.childList;if(ac.length==1){if(tn!!==ac[0]){throw"removeChild: invalid child";}
return this.removeChildren();}
if(tn===this.tree.activeNode){tn.deactivate();}
if(this.tree.options.persist){if(tn.bSelected){this.tree.persistence.clearSelect(tn.data.key);}
if(tn.bExpanded){this.tree.persistence.clearExpand(tn.data.key);}}
tn.removeChildren(true);this.ul.removeChild(tn.li);for(var i=0,l=ac.length;i<l;i++){if(ac[i]===tn){this.childList.splice(i,1);break;}}},removeChildren:function(isRecursiveCall,retainPersistence){this.tree.logDebug("%s.removeChildren(%o)",this,isRecursiveCall);var tree=this.tree;var ac=this.childList;if(ac){for(var i=0,l=ac.length;i<l;i++){var tn=ac[i];if(tn===tree.activeNode&&!!retainPersistence){tn.deactivate();}
if(this.tree.options.persist&&!!retainPersistence){if(tn.bSelected){this.tree.persistence.clearSelect(tn.data.key);}
if(tn.bExpanded){this.tree.persistence.clearExpand(tn.data.key);}}
tn.removeChildren(true,retainPersistence);if(this.ul){this.ul.removeChild(tn.li);}}
this.childList=null;}
if(!!isRecursiveCall){this.isLoading=false;this.render();}},setTitle:function(title){this.fromDict({title:title});},reload:function(force){throw"Use reloadChildren() instead";},reloadChildren:function(callback){if(this.parent===null){throw"Use tree.reload() instead";}else if(!!this.data.isLazy){throw"node.reloadChildren() requires lazy nodes.";}
if(callback){var self=this;var eventType="nodeLoaded.dynatree."+this.tree.$tree.attr("id")
+"."+this.data.key;this.tree.$tree.bind(eventType,function(e,node,isOk){self.tree.$tree.unbind(eventType);self.tree.logInfo("loaded %o, %o, %o",e,node,isOk);if(node!!==self){throw"got invalid load event";}
callback.call(self.tree,node,isOk);});}
this.removeChildren();this._loadContent();},_loadKeyPath:function(keyPath,callback){var tree=this.tree;tree.logDebug("%s._loadKeyPath(%s)",this,keyPath);if(keyPath===""){throw"Key path must not be empty";}
var segList=keyPath.split(tree.options.keyPathSeparator);if(segList[0]===""){throw"Key path must be relative (don''t start with ''/'')";}
var seg=segList.shift();for(var i=0,l=this.childList.length;i<l;i++){var child=this.childList[i];if(child.data.key===seg){if(segList.length===0){callback.call(tree,child,"ok");}else if(child.data.isLazy&&(child.childList===null||child.childList===undefined)){tree.logDebug("%s._loadKeyPath(%s) -> reloading %s...",this,keyPath,child);var self=this;child.reloadChildren(function(node,isOk){if(isOk){tree.logDebug("%s._loadKeyPath(%s) -> reloaded %s.",node,keyPath,node);callback.call(tree,child,"loaded");node._loadKeyPath(segList.join(tree.options.keyPathSeparator),callback);}else{tree.logWarning("%s._loadKeyPath(%s) -> reloadChildren() failed.",self,keyPath);callback.call(tree,child,"error");}});}else{callback.call(tree,child,"loaded");child._loadKeyPath(segList.join(tree.options.keyPathSeparator),callback);}
return;}}
tree.logWarning("Node not found: "+seg);return;},resetLazy:function(){if(this.parent===null){throw"Use tree.reload() instead";}else if(!!this.data.isLazy){throw"node.resetLazy() requires lazy nodes.";}
this.expand(false);this.removeChildren();},_addChildNode:function(dtnode,beforeNode){var tree=this.tree;var opts=tree.options;var pers=tree.persistence;dtnode.parent=this;if(this.childList===null){this.childList=[];}else if(!!beforeNode){if(this.childList.length>0){$(this.childList[this.childList.length-1].span).removeClass(opts.classNames.lastsib);}}
if(beforeNode){var iBefore=$.inArray(beforeNode,this.childList);if(iBefore<0){throw"<beforeNode> must be a child of <this>";}
this.childList.splice(iBefore,0,dtnode);}else{this.childList.push(dtnode);}
var isInitializing=tree.isInitializing();if(opts.persist&&pers.cookiesFound&&isInitializing){if(pers.activeKey==dtnode.data.key){tree.activeNode=dtnode;}
if(pers.focusedKey==dtnode.data.key){tree.focusNode=dtnode;}
dtnode.bExpanded=($.inArray(dtnode.data.key,pers.expandedKeyList)>=0);dtnode.bSelected=($.inArray(dtnode.data.key,pers.selectedKeyList)>=0);}else{if(dtnode.data.activate){tree.activeNode=dtnode;if(opts.persist){pers.activeKey=dtnode.data.key;}}
if(dtnode.data.focus){tree.focusNode=dtnode;if(opts.persist){pers.focusedKey=dtnode.data.key;}}
dtnode.bExpanded=(dtnode.data.expand===true);if(dtnode.bExpanded&&opts.persist){pers.addExpand(dtnode.data.key);}
dtnode.bSelected=(dtnode.data.select===true);if(dtnode.bSelected&&opts.persist){pers.addSelect(dtnode.data.key);}}
if(opts.minExpandLevel>=dtnode.getLevel()){this.bExpanded=true;}
if(dtnode.bSelected&&opts.selectMode==3){var p=this;while(p){if(!!p.hasSubSel){p._setSubSel(true);}
p=p.parent;}}
if(tree.bEnableUpdate){this.render();}
return dtnode;},addChild:function(obj,beforeNode){if(typeof(obj)=="string"){throw"Invalid data type for "+obj;}else if(!!obj||obj.length===0){return;}else if(obj instanceof DynaTreeNode){return this._addChildNode(obj,beforeNode);}
if(!!obj.length){obj=[obj];}
var prevFlag=this.tree.enableUpdate(false);var tnFirst=null;for(var i=0,l=obj.length;i<l;i++){var data=obj[i];var dtnode=this._addChildNode(new DynaTreeNode(this,this.tree,data),beforeNode);if(!!tnFirst){tnFirst=dtnode;}
if(data.children){dtnode.addChild(data.children,null);}}
this.tree.enableUpdate(prevFlag);return tnFirst;},append:function(obj){this.tree.logWarning("node.append() is deprecated (use node.addChild() instead).");return this.addChild(obj,null);},appendAjax:function(ajaxOptions){var self=this;this.removeChildren(false,true);this.setLazyNodeStatus(DTNodeStatus_Loading);if(ajaxOptions.debugLazyDelay){var ms=ajaxOptions.debugLazyDelay;ajaxOptions.debugLazyDelay=0;this.tree.logInfo("appendAjax: waiting for debugLazyDelay "+ms);setTimeout(function(){self.appendAjax(ajaxOptions);},ms);return;}
var orgSuccess=ajaxOptions.success;var orgError=ajaxOptions.error;var eventType="nodeLoaded.dynatree."+this.tree.$tree.attr("id")
+"."+this.data.key;var options=$.extend({},this.tree.options.ajaxDefaults,ajaxOptions,{success:function(data,textStatus){var prevPhase=self.tree.phase;self.tree.phase="init";if(options.postProcess){data=options.postProcess.call(this,data,this.dataType);}
if(!!$.isArray(data)||data.length!!==0){self.addChild(data,null);}
self.tree.phase="postInit";if(orgSuccess){orgSuccess.call(options,self);}
self.tree.logInfo("trigger "+eventType);self.tree.$tree.trigger(eventType,[self,true]);self.tree.phase=prevPhase;self.setLazyNodeStatus(DTNodeStatus_Ok);if($.isArray(data)&&data.length===0){self.childList=[];self.render();}},error:function(XMLHttpRequest,textStatus,errorThrown){self.tree.logWarning("appendAjax failed:",textStatus,":\n",XMLHttpRequest,"\n",errorThrown);if(orgError){orgError.call(options,self,XMLHttpRequest,textStatus,errorThrown);}
self.tree.$tree.trigger(eventType,[self,false]);self.setLazyNodeStatus(DTNodeStatus_Error,{info:textStatus,tooltip:""+errorThrown});}});$.ajax(options);},move:function(targetNode,mode){var pos;if(this===targetNode){return;}
if(!!this.parent){throw"Cannot move system root";}
if(mode===undefined||mode=="over"){mode="child";}
var prevParent=this.parent;var targetParent=(mode==="child")?targetNode:targetNode.parent;if(targetParent.isDescendantOf(this)){throw"Cannot move a node to it''s own descendant";}
if(this.parent.childList.length==1){this.parent.childList=null;this.parent.bExpanded=false;}else{pos=$.inArray(this,this.parent.childList);if(pos<0){throw"Internal error";}
this.parent.childList.splice(pos,1);}
this.parent.ul.removeChild(this.li);this.parent=targetParent;if(targetParent.hasChildren()){switch(mode){case"child":targetParent.childList.push(this);break;case"before":pos=$.inArray(targetNode,targetParent.childList);if(pos<0){throw"Internal error";}
targetParent.childList.splice(pos,0,this);break;case"after":pos=$.inArray(targetNode,targetParent.childList);if(pos<0){throw"Internal error";}
targetParent.childList.splice(pos+1,0,this);break;default:throw"Invalid mode "+mode;}}else{targetParent.childList=[this];if(!!targetParent.ul){targetParent.ul=document.createElement("ul");targetParent.ul.style.display="none";targetParent.li.appendChild(targetParent.ul);}}
targetParent.ul.appendChild(this.li);if(this.tree!!==targetNode.tree){this.visit(function(node){node.tree=targetNode.tree;},null,true);throw"Not yet implemented.";}
if(!!prevParent.isDescendantOf(targetParent)){prevParent.render();}
if(!!targetParent.isDescendantOf(prevParent)){targetParent.render();}},lastentry:undefined};var DynaTreeStatus=Class.create();DynaTreeStatus._getTreePersistData=function(cookieId,cookieOpts){var ts=new DynaTreeStatus(cookieId,cookieOpts);ts.read();return ts.toDict();};getDynaTreePersistData=DynaTreeStatus._getTreePersistData;DynaTreeStatus.prototype={initialize:function(cookieId,cookieOpts){this._log("DynaTreeStatus: initialize");if(cookieId===undefined){cookieId=$.ui.dynatree.prototype.options.cookieId;}
cookieOpts=$.extend({},$.ui.dynatree.prototype.options.cookie,cookieOpts);this.cookieId=cookieId;this.cookieOpts=cookieOpts;this.cookiesFound=undefined;this.activeKey=null;this.focusedKey=null;this.expandedKeyList=null;this.selectedKeyList=null;},_log:function(msg){Array.prototype.unshift.apply(arguments,["debug"]);_log.apply(this,arguments);},read:function(){this._log("DynaTreeStatus: read");this.cookiesFound=false;var cookie=$.cookie(this.cookieId+"-active");this.activeKey=(cookie===null)?"":cookie;if(cookie!!==null){this.cookiesFound=true;}
cookie=$.cookie(this.cookieId+"-focus");this.focusedKey=(cookie===null)?"":cookie;if(cookie!!==null){this.cookiesFound=true;}
cookie=$.cookie(this.cookieId+"-expand");this.expandedKeyList=(cookie===null)?[]:cookie.split(",");if(cookie!!==null){this.cookiesFound=true;}
cookie=$.cookie(this.cookieId+"-select");this.selectedKeyList=(cookie===null)?[]:cookie.split(",");if(cookie!!==null){this.cookiesFound=true;}},write:function(){this._log("DynaTreeStatus: write");$.cookie(this.cookieId+"-active",(this.activeKey===null)?"":this.activeKey,this.cookieOpts);$.cookie(this.cookieId+"-focus",(this.focusedKey===null)?"":this.focusedKey,this.cookieOpts);$.cookie(this.cookieId+"-expand",(this.expandedKeyList===null)?"":this.expandedKeyList.join(","),this.cookieOpts);$.cookie(this.cookieId+"-select",(this.selectedKeyList===null)?"":this.selectedKeyList.join(","),this.cookieOpts);},addExpand:function(key){this._log("addExpand(%o)",key);if($.inArray(key,this.expandedKeyList)<0){this.expandedKeyList.push(key);$.cookie(this.cookieId+"-expand",this.expandedKeyList.join(","),this.cookieOpts);}},clearExpand:function(key){this._log("clearExpand(%o)",key);var idx=$.inArray(key,this.expandedKeyList);if(idx>=0){this.expandedKeyList.splice(idx,1);$.cookie(this.cookieId+"-expand",this.expandedKeyList.join(","),this.cookieOpts);}},addSelect:function(key){this._log("addSelect(%o)",key);if($.inArray(key,this.selectedKeyList)<0){this.selectedKeyList.push(key);$.cookie(this.cookieId+"-select",this.selectedKeyList.join(","),this.cookieOpts);}},clearSelect:function(key){this._log("clearSelect(%o)",key);var idx=$.inArray(key,this.selectedKeyList);if(idx>=0){this.selectedKeyList.splice(idx,1);$.cookie(this.cookieId+"-select",this.selectedKeyList.join(","),this.cookieOpts);}},isReloading:function(){return this.cookiesFound===true;},toDict:function(){return{cookiesFound:this.cookiesFound,activeKey:this.activeKey,focusedKey:this.activeKey,expandedKeyList:this.expandedKeyList,selectedKeyList:this.selectedKeyList};},lastentry:undefined};var DynaTree=Class.create();DynaTree.version="$Version: 1.1.1$";DynaTree.prototype={initialize:function($widget){this.phase="init";this.$widget=$widget;this.options=$widget.options;this.$tree=$widget.element;this.timer=null;this.divTree=this.$tree.get(0);_initDragAndDrop(this);},_load:function(callback){var $widget=this.$widget;var opts=this.options;this.bEnableUpdate=true;this._nodeCount=1;this.activeNode=null;this.focusNode=null;if(opts.rootVisible!!==undefined){_log("warn","Option ''rootVisible'' is no longer supported.");}
if(opts.minExpandLevel<1){_log("warn","Option ''minExpandLevel'' must be >= 1.");opts.minExpandLevel=1;}
if(opts.classNames!!==$.ui.dynatree.prototype.options.classNames){opts.classNames=$.extend({},$.ui.dynatree.prototype.options.classNames,opts.classNames);}
if(opts.ajaxDefaults!!==$.ui.dynatree.prototype.options.ajaxDefaults){opts.ajaxDefaults=$.extend({},$.ui.dynatree.prototype.options.ajaxDefaults,opts.ajaxDefaults);}
if(opts.dnd!!==$.ui.dynatree.prototype.options.dnd){opts.dnd=$.extend({},$.ui.dynatree.prototype.options.dnd,opts.dnd);}
if(!!opts.imagePath){$("script").each(function(){var _rexDtLibName=/.*dynatree[^\/]*\.js$/i;if(this.src.search(_rexDtLibName)>=0){if(this.src.indexOf("/")>=0){opts.imagePath=this.src.slice(0,this.src.lastIndexOf("/"))+"/skin/";}else{opts.imagePath="skin/";}
logMsg("Guessing imagePath from ''%s'': ''%s''",this.src,opts.imagePath);return false;}});}
this.persistence=new DynaTreeStatus(opts.cookieId,opts.cookie);if(opts.persist){if(!!$.cookie){_log("warn","Please include jquery.cookie.js to use persistence.");}
this.persistence.read();}
this.logDebug("DynaTree.persistence: %o",this.persistence.toDict());this.cache={tagEmpty:"<span class=''"+opts.classNames.empty+"''></span>",tagVline:"<span class=''"+opts.classNames.vline+"''></span>",tagExpander:"<span class=''"+opts.classNames.expander+"''></span>",tagConnector:"<span class=''"+opts.classNames.connector+"''></span>",tagNodeIcon:"<span class=''"+opts.classNames.nodeIcon+"''></span>",tagCheckbox:"<span class=''"+opts.classNames.checkbox+"''></span>",lastentry:undefined};if(opts.children||(opts.initAjax&&opts.initAjax.url)||opts.initId){$(this.divTree).empty();}
var $ulInitialize=this.$tree.find(">ul:first").hide();this.tnRoot=new DynaTreeNode(null,this,{});this.tnRoot.bExpanded=true;this.tnRoot.render();this.divTree.appendChild(this.tnRoot.ul);var root=this.tnRoot;var isReloading=(opts.persist&&this.persistence.isReloading());var isLazy=false;var prevFlag=this.enableUpdate(false);this.logDebug("Dynatree._load(): read tree structure...");if(opts.children){root.addChild(opts.children);}else if(opts.initAjax&&opts.initAjax.url){isLazy=true;root.data.isLazy=true;this._reloadAjax(callback);}else if(opts.initId){this._createFromTag(root,$("#"+opts.initId));}else{this._createFromTag(root,$ulInitialize);$ulInitialize.remove();}
this._checkConsistency();this.logDebug("Dynatree._load(): render nodes...");this.enableUpdate(prevFlag);this.logDebug("Dynatree._load(): bind events...");this.$widget.bind();this.logDebug("Dynatree._load(): postInit...");this.phase="postInit";if(opts.persist){this.persistence.write();}
if(this.focusNode&&this.focusNode.isVisible()){this.logDebug("Focus on init: %o",this.focusNode);this.focusNode.focus();}
if(!!isLazy&&opts.onPostInit){opts.onPostInit.call(this,isReloading,false);}
this.phase="idle";},_reloadAjax:function(callback){var opts=this.options;if(!!opts.initAjax||!!opts.initAjax.url){throw"tree.reload() requires ''initAjax'' mode.";}
var pers=this.persistence;var ajaxOpts=$.extend({},opts.initAjax);if(ajaxOpts.addActiveKey){ajaxOpts.data.activeKey=pers.activeKey;}
if(ajaxOpts.addFocusedKey){ajaxOpts.data.focusedKey=pers.focusedKey;}
if(ajaxOpts.addExpandedKeyList){ajaxOpts.data.expandedKeyList=pers.expandedKeyList.join(",");}
if(ajaxOpts.addSelectedKeyList){ajaxOpts.data.selectedKeyList=pers.selectedKeyList.join(",");}
if(opts.onPostInit){if(ajaxOpts.success){this.logWarning("initAjax: success callback is ignored when onPostInit was specified.");}
if(ajaxOpts.error){this.logWarning("initAjax: error callback is ignored when onPostInit was specified.");}
var isReloading=pers.isReloading();ajaxOpts.success=function(dtnode){opts.onPostInit.call(dtnode.tree,isReloading,false);if(callback){callback.call(dtnode.tree,"ok");}};ajaxOpts.error=function(dtnode){opts.onPostInit.call(dtnode.tree,isReloading,true);if(callback){callback.call(dtnode.tree,"error");}};}
this.logDebug("Dynatree._init(): send Ajax request...");this.tnRoot.appendAjax(ajaxOpts);},toString:function(){return"Dynatree ''"+this.$tree.attr("id")+"''";},toDict:function(){return this.tnRoot.toDict(true);},serializeArray:function(stopOnParents){var nodeList=this.getSelectedNodes(stopOnParents),name=this.$tree.attr("name")||this.$tree.attr("id"),arr=[];for(var i=0,l=nodeList.length;i<l;i++){arr.push({name:name,value:nodeList[i].data.key});}
return arr;},getPersistData:function(){return this.persistence.toDict();},logDebug:function(msg){if(this.options.debugLevel>=2){Array.prototype.unshift.apply(arguments,["debug"]);_log.apply(this,arguments);}},logInfo:function(msg){if(this.options.debugLevel>=1){Array.prototype.unshift.apply(arguments,["info"]);_log.apply(this,arguments);}},logWarning:function(msg){Array.prototype.unshift.apply(arguments,["warn"]);_log.apply(this,arguments);},isInitializing:function(){return(this.phase=="init"||this.phase=="postInit");},isReloading:function(){return(this.phase=="init"||this.phase=="postInit")&&this.options.persist&&this.persistence.cookiesFound;},isUserEvent:function(){return(this.phase=="userEvent");},redraw:function(){this.tnRoot.render(false,false);},renderInvisibleNodes:function(){this.tnRoot.render(false,true);},reload:function(callback){this._load(callback);},getRoot:function(){return this.tnRoot;},enable:function(){this.$widget.enable();},disable:function(){this.$widget.disable();},getNodeByKey:function(key){var el=document.getElementById(this.options.idPrefix+key);if(el){return el.dtnode?el.dtnode:null;}
var match=null;this.visit(function(node){if(node.data.key==key){match=node;return false;}},true);return match;},getActiveNode:function(){return this.activeNode;},reactivate:function(setFocus){var node=this.activeNode;if(node){this.activeNode=null;node.activate();if(setFocus){node.focus();}}},getSelectedNodes:function(stopOnParents){var nodeList=[];this.tnRoot.visit(function(node){if(node.bSelected){nodeList.push(node);if(stopOnParents===true){return"skip";}}});return nodeList;},activateKey:function(key){var dtnode=(key===null)?null:this.getNodeByKey(key);if(!!dtnode){if(this.activeNode){this.activeNode.deactivate();}
this.activeNode=null;return null;}
dtnode.focus();dtnode.activate();return dtnode;},loadKeyPath:function(keyPath,callback){var segList=keyPath.split(this.options.keyPathSeparator);if(segList[0]===""){segList.shift();}
if(segList[0]==this.tnRoot.data.key){this.logDebug("Removed leading root key.");segList.shift();}
keyPath=segList.join(this.options.keyPathSeparator);return this.tnRoot._loadKeyPath(keyPath,callback);},selectKey:function(key,select){var dtnode=this.getNodeByKey(key);if(!!dtnode){return null;}
dtnode.select(select);return dtnode;},enableUpdate:function(bEnable){if(this.bEnableUpdate==bEnable){return bEnable;}
this.bEnableUpdate=bEnable;if(bEnable){this.redraw();}
return!!bEnable;},count:function(){return this.tnRoot.countChildren();},visit:function(fn,includeRoot){return this.tnRoot.visit(fn,includeRoot);},_createFromTag:function(parentTreeNode,$ulParent){var self=this;$ulParent.find(">li").each(function(){var $li=$(this);var $liSpan=$li.find(">span:first");var title;if($liSpan.length){title=$liSpan.html();}else{title=$li.html();var iPos=title.search(/<ul/i);if(iPos>=0){title=$.trim(title.substring(0,iPos));}else{title=$.trim(title);}}
var data={title:title,isFolder:$li.hasClass("folder"),isLazy:$li.hasClass("lazy"),expand:$li.hasClass("expanded"),select:$li.hasClass("selected"),activate:$li.hasClass("active"),focus:$li.hasClass("focused"),noLink:$li.hasClass("noLink")};if($li.attr("title")){data.tooltip=$li.attr("title");}
if($li.attr("id")){data.key=$li.attr("id");}
if($li.attr("data")){var dataAttr=$.trim($li.attr("data"));if(dataAttr){if(dataAttr.charAt(0)!!="{"){dataAttr="{"+dataAttr+"}";}
try{$.extend(data,eval("("+dataAttr+")"));}catch(e){throw("Error parsing node data: "+e+"\ndata:\n''"+dataAttr+"''");}}}
var childNode=parentTreeNode.addChild(data);var $ul=$li.find(">ul:first");if($ul.length){self._createFromTag(childNode,$ul);}});},_checkConsistency:function(){},_setDndStatus:function(sourceNode,targetNode,helper,hitMode,accept){var $source=sourceNode?$(sourceNode.span):null;var $target=$(targetNode.span);if(!!this.$dndMarker){this.$dndMarker=$("<div id=''dynatree-drop-marker''></div>").hide().prependTo($(this.divTree).parent());}
if(hitMode==="after"||hitMode==="before"||hitMode==="over"){var pos=$target.position();switch(hitMode){case"before":this.$dndMarker.removeClass("dynatree-drop-after dynatree-drop-over");this.$dndMarker.addClass("dynatree-drop-before");pos.top-=8;break;case"after":this.$dndMarker.removeClass("dynatree-drop-before dynatree-drop-over");this.$dndMarker.addClass("dynatree-drop-after");pos.top+=8;break;default:this.$dndMarker.removeClass("dynatree-drop-after dynatree-drop-before");this.$dndMarker.addClass("dynatree-drop-over");$target.addClass("dynatree-drop-target");pos.left+=8;}
this.$dndMarker.css({"left":(pos.left)+"px","top":(pos.top)+"px"}).show();}else{$target.removeClass("dynatree-drop-target");this.$dndMarker.hide();}
if(hitMode==="after"){$target.addClass("dynatree-drop-after");}else{$target.removeClass("dynatree-drop-after");}
if(hitMode==="before"){$target.addClass("dynatree-drop-before");}else{$target.removeClass("dynatree-drop-before");}
if(accept===true){if($source){$source.addClass("dynatree-drop-accept");}
$target.addClass("dynatree-drop-accept");helper.addClass("dynatree-drop-accept");}else{if($source){$source.removeClass("dynatree-drop-accept");}
$target.removeClass("dynatree-drop-accept");helper.removeClass("dynatree-drop-accept");}
if(accept===false){if($source){$source.addClass("dynatree-drop-reject");}
$target.addClass("dynatree-drop-reject");helper.addClass("dynatree-drop-reject");}else{if($source){$source.removeClass("dynatree-drop-reject");}
$target.removeClass("dynatree-drop-reject");helper.removeClass("dynatree-drop-reject");}},_onDragEvent:function(eventName,node,otherNode,event,ui,draggable){var opts=this.options;var dnd=this.options.dnd;var res=null;var nodeTag=$(node.span);var hitMode;switch(eventName){case"helper":var helper=$("<div class=''dynatree-drag-helper''><span class=''dynatree-drag-helper-img'' /></div>").append($(event.target).closest(''a'').clone());helper.data("dtSourceNode",node);res=helper;break;case"start":if(node.isStatusNode()){res=false;}else if(dnd.onDragStart){res=dnd.onDragStart(node);}
if(res===false){this.logDebug("tree.onDragStart() cancelled");ui.helper.trigger("mouseup");ui.helper.hide();}else{nodeTag.addClass("dynatree-drag-source");}
break;case"enter":res=dnd.onDragEnter?dnd.onDragEnter(node,otherNode):null;res={over:(res!!==false)&&((res===true)||(res==="over")||$.inArray("over",res)>=0),before:(res!!==false)&&((res===true)||(res==="before")||$.inArray("before",res)>=0),after:(res!!==false)&&((res===true)||(res==="after")||$.inArray("after",res)>=0)};ui.helper.data("enterResponse",res);break;case"over":var enterResponse=ui.helper.data("enterResponse");hitMode=null;if(enterResponse===false){break;}else if(typeof enterResponse==="string"){hitMode=enterResponse;}else{var nodeOfs=nodeTag.offset();var relPos={x:event.pageX-nodeOfs.left,y:event.pageY-nodeOfs.top};var relPos2={x:relPos.x/nodeTag.width(),y:relPos.y/nodeTag.height()};if(enterResponse.after&&relPos2.y>0.75){hitMode="after";}else if(!!enterResponse.over&&enterResponse.after&&relPos2.y>0.5){hitMode="after";}else if(enterResponse.before&&relPos2.y<=0.25){hitMode="before";}else if(!!enterResponse.over&&enterResponse.before&&relPos2.y<=0.5){hitMode="before";}else if(enterResponse.over){hitMode="over";}
if(dnd.preventVoidMoves){if(node===otherNode){hitMode=null;}else if(hitMode==="before"&&otherNode&&node===otherNode.getNextSibling()){hitMode=null;}else if(hitMode==="after"&&otherNode&&node===otherNode.getPrevSibling()){hitMode=null;}else if(hitMode==="over"&&otherNode&&otherNode.parent===node&&otherNode.isLastSibling()){hitMode=null;}}
ui.helper.data("hitMode",hitMode);}
if(hitMode==="over"&&dnd.autoExpandMS&&node.hasChildren()!!==false&&!!node.bExpanded){node.scheduleAction("expand",dnd.autoExpandMS);}
if(hitMode&&dnd.onDragOver){res=dnd.onDragOver(node,otherNode,hitMode);}
this._setDndStatus(otherNode,node,ui.helper,hitMode,res!!==false);break;case"drop":hitMode=ui.helper.data("hitMode");if(hitMode&&dnd.onDrop){dnd.onDrop(node,otherNode,hitMode,ui,draggable);}
break;case"leave":node.scheduleAction("cancel");ui.helper.data("enterResponse",null);ui.helper.data("hitMode",null);this._setDndStatus(otherNode,node,ui.helper,"out",undefined);if(dnd.onDragLeave){dnd.onDragLeave(node,otherNode);}
break;case"stop":nodeTag.removeClass("dynatree-drag-source");if(dnd.onDragStop){dnd.onDragStop(node);}
break;default:throw"Unsupported drag event: "+eventName;}
return res;},cancelDrag:function(){var dd=$.ui.ddmanager.current;if(dd){dd.cancel();}},lastentry:undefined};$.widget("ui.dynatree",{_init:function(){if(parseFloat($.ui.version)<1.8){_log("warn","ui.dynatree._init() was called; you should upgrade to jquery.ui.core.js v1.8 or higher.");return this._create();}
_log("debug","ui.dynatree._init() was called; no current default functionality.");},_create:function(){logMsg("Dynatree._create(): version=''%s'', debugLevel=%o.",DynaTree.version,this.options.debugLevel);var opts=this.options;this.options.event+=".dynatree";var divTree=this.element.get(0);this.tree=new DynaTree(this);this.tree._load();this.tree.logDebug("Dynatree._init(): done.");},bind:function(){this.unbind();var eventNames="click.dynatree dblclick.dynatree";if(this.options.keyboard){eventNames+=" keypress.dynatree keydown.dynatree";}
this.element.bind(eventNames,function(event){var dtnode=getDtNodeFromElement(event.target);if(!!dtnode){return true;}
var tree=dtnode.tree;var o=tree.options;tree.logDebug("event(%s): dtnode: %s",event.type,dtnode);var prevPhase=tree.phase;tree.phase="userEvent";try{switch(event.type){case"click":return(o.onClick&&o.onClick.call(tree,dtnode,event)===false)?false:dtnode._onClick(event);case"dblclick":return(o.onDblClick&&o.onDblClick.call(tree,dtnode,event)===false)?false:dtnode._onDblClick(event);case"keydown":return(o.onKeydown&&o.onKeydown.call(tree,dtnode,event)===false)?false:dtnode._onKeydown(event);case"keypress":return(o.onKeypress&&o.onKeypress.call(tree,dtnode,event)===false)?false:dtnode._onKeypress(event);}}catch(e){var _=null;tree.logWarning("bind(%o): dtnode: %o, error: %o",event,dtnode,e);}finally{tree.phase=prevPhase;}});function __focusHandler(event){event=$.event.fix(event||window.event);var dtnode=getDtNodeFromElement(event.target);return dtnode?dtnode._onFocus(event):false;}
var div=this.tree.divTree;if(div.addEventListener){div.addEventListener("focus",__focusHandler,true);div.addEventListener("blur",__focusHandler,true);}else{div.onfocusin=div.onfocusout=__focusHandler;}},unbind:function(){this.element.unbind(".dynatree");},enable:function(){this.bind();$.Widget.prototype.enable.apply(this,arguments);},disable:function(){this.unbind();$.Widget.prototype.disable.apply(this,arguments);},getTree:function(){return this.tree;},getRoot:function(){return this.tree.getRoot();},getActiveNode:function(){return this.tree.getActiveNode();},getSelectedNodes:function(){return this.tree.getSelectedNodes();},lastentry:undefined});if(parseFloat($.ui.version)<1.8){$.ui.dynatree.getter="getTree getRoot getActiveNode getSelectedNodes";}
$.ui.dynatree.prototype.options={title:"Dynatree",minExpandLevel:1,imagePath:null,children:null,initId:null,initAjax:null,autoFocus:true,keyboard:true,persist:false,autoCollapse:false,clickFolderMode:3,activeVisible:true,checkbox:false,selectMode:2,fx:null,noLink:false,onClick:null,onDblClick:null,onKeydown:null,onKeypress:null,onFocus:null,onBlur:null,onQueryActivate:null,onQuerySelect:null,onQueryExpand:null,onPostInit:null,onActivate:null,onDeactivate:null,onSelect:null,onExpand:null,onLazyRead:null,onCustomRender:null,onRender:null,dnd:{onDragStart:null,onDragStop:null,autoExpandMS:1000,preventVoidMoves:true,onDragEnter:null,onDragOver:null,onDrop:null,onDragLeave:null},ajaxDefaults:{cache:false,dataType:"json"},strings:{loading:"Loading&#8230;",loadError:"Load error!!"},generateIds:false,idPrefix:"dynatree-id-",keyPathSeparator:"/",cookieId:"dynatree",cookie:{expires:null},classNames:{container:"dynatree-container",node:"dynatree-node",folder:"dynatree-folder",empty:"dynatree-empty",vline:"dynatree-vline",expander:"dynatree-expander",connector:"dynatree-connector",checkbox:"dynatree-checkbox",nodeIcon:"dynatree-icon",title:"dynatree-title",noConnector:"dynatree-no-connector",nodeError:"dynatree-statusnode-error",nodeWait:"dynatree-statusnode-wait",hidden:"dynatree-hidden",combinedExpanderPrefix:"dynatree-exp-",combinedIconPrefix:"dynatree-ico-",nodeLoading:"dynatree-loading",hasChildren:"dynatree-has-children",active:"dynatree-active",selected:"dynatree-selected",expanded:"dynatree-expanded",lazy:"dynatree-lazy",focused:"dynatree-focused",partsel:"dynatree-partsel",lastsib:"dynatree-lastsib"},debugLevel:1,lastentry:undefined};if(parseFloat($.ui.version)<1.8){$.ui.dynatree.defaults=$.ui.dynatree.prototype.options;}
$.ui.dynatree.nodedatadefaults={title:null,key:null,isFolder:false,isLazy:false,tooltip:null,icon:null,addClass:null,noLink:false,activate:false,focus:false,expand:false,select:false,hideCheckbox:false,unselectable:false,children:null,lastentry:undefined};function _initDragAndDrop(tree){var dnd=tree.options.dnd||null;if(dnd&&(dnd.onDragStart||dnd.onDrop)){_registerDnd();}
if(dnd&&dnd.onDragStart){tree.$tree.draggable({addClasses:false,appendTo:"body",containment:false,delay:0,distance:4,revert:false,connectToDynatree:true,helper:function(event){var sourceNode=getDtNodeFromElement(event.target);return sourceNode.tree._onDragEvent("helper",sourceNode,null,event,null,null);},_last:null});}
if(dnd&&dnd.onDrop){tree.$tree.droppable({addClasses:false,tolerance:"intersect",greedy:false,_last:null});}}
var didRegisterDnd=false;var _registerDnd=function(){if(didRegisterDnd){return;}
$.ui.plugin.add("draggable","connectToDynatree",{start:function(event,ui){var draggable=$(this).data("draggable");var sourceNode=ui.helper.data("dtSourceNode")||null;if(sourceNode){draggable.offset.click.top=-2;draggable.offset.click.left=+16;return sourceNode.tree._onDragEvent("start",sourceNode,null,event,ui,draggable);}},drag:function(event,ui){var draggable=$(this).data("draggable");var sourceNode=ui.helper.data("dtSourceNode")||null;var prevTargetNode=ui.helper.data("dtTargetNode")||null;var targetNode=getDtNodeFromElement(event.target);if(event.target&&!!targetNode){var isHelper=$(event.target).closest("div.dynatree-drag-helper,#dynatree-drop-marker").length>0;if(isHelper){return;}}
ui.helper.data("dtTargetNode",targetNode);if(prevTargetNode&&prevTargetNode!!==targetNode){prevTargetNode.tree._onDragEvent("leave",prevTargetNode,sourceNode,event,ui,draggable);}
if(targetNode){if(!!targetNode.tree.options.dnd.onDrop){noop();}else if(targetNode===prevTargetNode){targetNode.tree._onDragEvent("over",targetNode,sourceNode,event,ui,draggable);}else{targetNode.tree._onDragEvent("enter",targetNode,sourceNode,event,ui,draggable);}}},stop:function(event,ui){var draggable=$(this).data("draggable");var sourceNode=ui.helper.data("dtSourceNode")||null;var targetNode=ui.helper.data("dtTargetNode")||null;var mouseDownEvent=draggable._mouseDownEvent;var eventType=event.type;var dropped=(eventType=="mouseup"&&event.which==1);if(!!dropped){logMsg("Drag was cancelled");}
if(targetNode){if(dropped){targetNode.tree._onDragEvent("drop",targetNode,sourceNode,event,ui,draggable);}
targetNode.tree._onDragEvent("leave",targetNode,sourceNode,event,ui,draggable);}
if(sourceNode){sourceNode.tree._onDragEvent("stop",sourceNode,null,event,ui,draggable);}}});didRegisterDnd=true;};})(jQuery);'! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*jqwidgetbox-dynatree-core' stamp: 'tbn 8/16/2011 21:46'!
loadingGif
	^ #(71 73 70 56 57 97 16 0 16 0 162 5 0 0 0 0 0 0 165 66 66 255 132 132 255 198 198 198 0 0 0 0 0 0 0 0 0 33 255 11 78 69 84 83 67 65 80 69 50 46 48 3 1 0 0 0 33 249 4 5 10 0 5 0 44 0 0 0 0 16 0 16 0 0 3 42 88 186 220 174 33 60 22 75 37 100 214 133 157 16 83 183 124 97 54 157 197 48 160 162 202 154 232 35 58 115 81 51 183 13 235 37 159 55 191 88 35 1 0 33 249 4 5 10 0 5 0 44 1 0 2 0 11 0 7 0 0 3 20 88 42 82 17 14 174 166 98 25 163 106 133 183 255 5 65 128 225 8 38 0 33 249 4 5 10 0 5 0 44 2 0 1 0 12 0 5 0 0 3 19 88 170 34 251 99 148 86 66 128 114 89 69 200 123 86 247 105 65 2 0 33 249 4 5 10 0 5 0 44 4 0 1 0 11 0 8 0 0 3 22 88 58 163 94 132 20 86 132 112 241 217 199 85 8 157 243 133 100 55 146 95 2 0 33 249 4 5 10 0 5 0 44 7 0 1 0 7 0 11 0 0 3 20 72 84 204 90 99 52 22 103 19 194 98 203 89 224 95 55 5 97 67 38 0 33 249 4 5 10 0 5 0 44 10 0 2 0 5 0 12 0 0 3 20 72 84 172 252 99 64 249 106 17 226 97 203 66 120 94 17 118 31 147 0 0 33 249 4 5 10 0 5 0 44 7 0 4 0 8 0 11 0 0 3 20 88 170 68 187 237 201 57 6 181 115 10 161 249 10 193 23 130 226 148 0 0 33 249 4 5 10 0 5 0 44 4 0 7 0 11 0 7 0 0 3 20 88 186 75 196 208 193 73 203 24 213 226 16 152 16 11 87 136 223 146 0 0 33 249 4 5 10 0 5 0 44 2 0 10 0 12 0 5 0 0 3 18 24 81 220 76 68 57 7 153 108 99 56 41 68 201 19 211 77 9 0 33 249 4 5 10 0 5 0 44 1 0 7 0 11 0 8 0 0 3 22 24 81 220 173 46 74 9 103 169 182 8 225 8 105 91 49 12 133 39 141 77 2 0 33 249 4 5 10 0 5 0 44 2 0 4 0 7 0 11 0 0 3 19 24 81 204 218 48 46 25 43 19 34 98 59 70 236 5 65 68 98 2 0 33 249 4 5 10 0 5 0 44 1 0 2 0 5 0 12 0 0 3 19 88 26 161 197 175 45 233 148 16 238 214 61 134 235 27 65 56 98 2 0 59) asByteArray! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*jqwidgetbox-dynatree-core' stamp: 'tbn 8/16/2011 21:44'!
uidynatreeCss
	^ '/*******************************************************************************
 * Tree container
 */
ul.dynatree-container
{
	font-family: tahoma, arial, helvetica;
	font-size: 10pt; /* font size should not be too big */
	white-space: nowrap;
	padding: 3px;

	background-color: white;
	border: 1px dotted gray;

	overflow: auto;
}

ul.dynatree-container ul
{
	padding: 0 0 0 16px;
	margin: 0;
}

ul.dynatree-container li
{
	list-style-image: none;
	list-style-position: outside;
	list-style-type: none;
	-moz-background-clip:border;
	-moz-background-inline-policy: continuous;
	-moz-background-origin: padding;
	background-attachment: scroll;
	background-color: transparent;
	background-repeat: repeat-y;
	background-image: url("vline.gif");
	background-position: 0 0;
	/*
	background-image: url("icons_96x256.gif");
	background-position: -80px -64px;
	*/
	margin: 0;
	padding: 1px 0 0 0;
}
/* Suppress lines for last child node */
ul.dynatree-container li.dynatree-lastsib
{
	background-image: none;
}
/* Suppress lines if level is fixed expanded (option minExpandLevel) */
ul.dynatree-no-connector > li
{
	background-image: none;
}

/* Style, when control is disabled */
.ui-dynatree-disabled ul.dynatree-container
{
	opacity: 0.5;
/*	filter: alpha(opacity=50); /* Yields a css warning */
	background-color: silver;
}

/*******************************************************************************
 * Common icon definitions
 */
span.dynatree-empty,
span.dynatree-vline,
span.dynatree-connector,
span.dynatree-expander,
span.dynatree-icon,
span.dynatree-checkbox,
span.dynatree-radio,
span.dynatree-drag-helper-img,
#dynatree-drop-marker
{
	width: 16px;
	height: 16px;
	display: -moz-inline-box; /* @ FF 1+2 */
	display: inline-block; /* Required to make a span sizeable */
	vertical-align: top;
	background-repeat: no-repeat;
	background-position: left;
	background-image: url("icons.gif");
	background-position: 0 0;
}

/** Used by ''icon'' node option: */
ul.dynatree-container img
{
	width: 16px;
	height: 16px;
	margin-left: 3px;
	vertical-align: top;
	border-style: none;
}


/*******************************************************************************
 * Lines and connectors
 */

span.dynatree-connector
{
	background-position: -16px -64px;
}

/*******************************************************************************
 * Expander icon
 * Note: IE6 doesn''t correctly evaluate multiples class names,
 *		 so we create combined class names that can be used in the CSS.
 *
 * Prefix: dynatree-exp-
 * 1st character: ''e'': expanded, ''c'': collapsed
 * 2nd character (optional): ''d'': lazy (Delayed)
 * 3rd character (optional): ''l'': Last sibling
 */

span.dynatree-expander
{
	background-position: 0px -80px;
	cursor: pointer;
}
.dynatree-exp-cl span.dynatree-expander /* Collapsed, not delayed, last sibling */
{
	background-position: 0px -96px;
}
.dynatree-exp-cd span.dynatree-expander /* Collapsed, delayed, not last sibling */
{
	background-position: -64px -80px;
}
.dynatree-exp-cdl span.dynatree-expander /* Collapsed, delayed, last sibling */
{
	background-position: -64px -96px;
}
.dynatree-exp-e span.dynatree-expander,  /* Expanded, not delayed, not last sibling */
.dynatree-exp-ed span.dynatree-expander  /* Expanded, delayed, not last sibling */
{
	background-position: -32px -80px;
}
.dynatree-exp-el span.dynatree-expander,  /* Expanded, not delayed, last sibling */
.dynatree-exp-edl span.dynatree-expander  /* Expanded, delayed, last sibling */
{
	background-position: -32px -96px;
}
.dynatree-loading span.dynatree-expander  /* ''Loading'' status overrides all others */
{
	background-position: 0 0;
	background-image: url("loading.gif");
}


/*******************************************************************************
 * Checkbox icon
 */
span.dynatree-checkbox
{
	margin-left: 3px;
	background-position: 0px -32px;
}
span.dynatree-checkbox:hover
{
	background-position: -16px -32px;
}

.dynatree-partsel span.dynatree-checkbox
{
	background-position: -64px -32px;
}
.dynatree-partsel span.dynatree-checkbox:hover
{
	background-position: -80px -32px;
}

.dynatree-selected span.dynatree-checkbox
{
	background-position: -32px -32px;
}
.dynatree-selected span.dynatree-checkbox:hover
{
	background-position: -48px -32px;
}

/*******************************************************************************
 * Radiobutton icon
 * This is a customization, that may be activated by overriding the ''checkbox''
 * class name as ''dynatree-radio'' in the tree options.
 */
span.dynatree-radio
{
	margin-left: 3px;
	background-position: 0px -48px;
}
span.dynatree-radio:hover
{
	background-position: -16px -48px;
}

.dynatree-partsel span.dynatree-radio
{
	background-position: -64px -48px;
}
.dynatree-partsel span.dynatree-radio:hover
{
	background-position: -80px -48px;
}

.dynatree-selected span.dynatree-radio
{
	background-position: -32px -48px;
}
.dynatree-selected span.dynatree-radio:hover
{
	background-position: -48px -48px;
}

/*******************************************************************************
 * Node type icon
 * Note: IE6 doesn''t correctly evaluate multiples class names,
 *		 so we create combined class names that can be used in the CSS.
 *
 * Prefix: dynatree-ico-
 * 1st character: ''e'': expanded, ''c'': collapsed
 * 2nd character (optional): ''f'': folder
 */

span.dynatree-icon /* Default icon */
{
	margin-left: 3px;
	background-position: 0px 0px;
}

.dynatree-ico-cf span.dynatree-icon  /* Collapsed Folder */
{
	background-position: 0px -16px;
}

.dynatree-ico-ef span.dynatree-icon  /* Expanded Folder */
{
	background-position: -64px -16px;
}

/* Status node icons */

.dynatree-statusnode-wait span.dynatree-icon
{
	background-image: url("loading.gif");
}

.dynatree-statusnode-error span.dynatree-icon
{
	background-position: 0px -112px;
/*	background-image: url("ltError.gif");*/
}

/*******************************************************************************
 * Node titles
 */

/* @Chrome: otherwise hit area of node titles is broken (issue 133)
   Removed again for issue 165; (133 couldn''t be reproduced) */
span.dynatree-node
{
/*  display: -moz-inline-box; /* @ FF 1+2 */
/*  display: inline-block; /* Required to make a span sizeable */
}


/* Remove blue color and underline from title links */
ul.dynatree-container a
/*, ul.dynatree-container a:visited*/
{
	color: black; /* inherit doesn''t work on IE */
	text-decoration: none;
	vertical-align: top;
	margin: 0px;
	margin-left: 3px;
/*	outline: 0; /* @ Firefox, prevent dotted border after click */
}

ul.dynatree-container a:hover
{
/*	text-decoration: underline; */
	background: #F2F7FD; /* light blue */
	border-color: #B8D6FB; /* darker light blue */
}

span.dynatree-node a
{
	display: inline-block; /* Better alignment, when title contains <br> */
/*	vertical-align: top;*/
	padding-left: 3px;
	padding-right: 3px; /* Otherwise italic font will be outside bounds */
	/*	line-height: 16px; /* should be the same as img height, in case 16 px */
}
span.dynatree-folder a
{
	font-weight: bold;
}

ul.dynatree-container a:focus,
span.dynatree-focused a:link  /* @IE */
{
	background-color: #EFEBDE; /* gray */
}

span.dynatree-has-children a
{
}

span.dynatree-expanded a
{
}

span.dynatree-selected a
{
	color: green;
	font-style: italic;
}

span.dynatree-active a
{
	background-color: #3169C6 !!important;
	color: white !!important; /* @ IE6 */
}

/*******************************************************************************
 * Drag''n''drop support
 */

/*** Helper object ************************************************************/
div.dynatree-drag-helper
{
}
div.dynatree-drag-helper a
{
	border: 1px solid gray;
	background-color: white;
	padding-left: 5px;
	padding-right: 5px;
	opacity: 0.8;
}
span.dynatree-drag-helper-img
{
	/*
	position: relative;
	left: -16px;
	*/
}
div.dynatree-drag-helper /*.dynatree-drop-accept*/
{

/*    border-color: green;
	background-color: red;*/
}
div.dynatree-drop-accept span.dynatree-drag-helper-img
{
	background-position: -32px -112px;
}
div.dynatree-drag-helper.dynatree-drop-reject
{
	border-color: red;
}
div.dynatree-drop-reject span.dynatree-drag-helper-img
{
	background-position: -16px -112px;
}

/*** Drop marker icon *********************************************************/

#dynatree-drop-marker
{
	width: 24px;
	position: absolute;
	background-position: 0 -128px;
}
#dynatree-drop-marker.dynatree-drop-after,
#dynatree-drop-marker.dynatree-drop-before
{
	width:64px;
	background-position: 0 -144px;
}
#dynatree-drop-marker.dynatree-drop-copy
{
	background-position: -64px -128px;
}
#dynatree-drop-marker.dynatree-drop-move
{
	background-position: -64px -128px;
}

/*** Source node while dragging ***********************************************/

span.dynatree-drag-source
{
	/* border: 1px dotted gray; */
	background-color: #e0e0e0;
}
span.dynatree-drag-source a
{
	color: gray;
}

/*** Target node while dragging cursor is over it *****************************/

span.dynatree-drop-target
{
	/*border: 1px solid gray;*/
}
span.dynatree-drop-target a
{
	/*background-repeat: no-repeat;
	background-position: right;
	background-image: url("drop_child.gif");*/
}
span.dynatree-drop-target.dynatree-drop-accept a
{
	/*border: 1px solid green;*/
	background-color: #3169C6 !!important;
	color: white !!important; /* @ IE6 */
	text-decoration: none;
}
span.dynatree-drop-target.dynatree-drop-reject
{
	/*border: 1px solid red;*/
}
span.dynatree-drop-target.dynatree-drop-after a
{
	/*background-repeat: repeat-x;
	background-position: bottom;
	background-image: url("drop_append.gif");*/
}


/*******************************************************************************
 * Custom node classes (sample)
 */

span.custom1 a
{
	background-color: maroon;
	color: yellow;
}
'! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*jqwidgetbox-dynatree-core' stamp: 'tbn 8/16/2011 21:45'!
vlineGif
	^ #(71 73 70 56 57 97 16 0 16 0 247 0 0 0 0 0 128 0 0 0 128 0 128 128 0 0 0 128 128 0 128 0 128 128 192 192 192 192 220 192 166 202 240 255 255 255 165 165 165 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 251 240 160 160 164 128 128 128 255 0 0 0 255 0 255 255 0 0 0 255 255 0 255 0 255 255 255 255 255 33 249 4 1 0 0 254 0 44 0 0 0 0 16 0 16 0 0 8 41 0 253 9 20 120 111 160 193 131 8 19 34 44 168 176 161 195 129 12 31 74 92 56 177 162 193 136 22 39 98 204 248 112 35 199 134 30 63 10 12 8 0 59) asByteArray! !
